package main

import (
	"bytes"
	"flag"
	"go/format"
	"io"
	"io/ioutil"
	"os"
	"strings"
)

func main() {
	outName := flag.String("o", "", "output file")
	flag.Parse()
	fs, err := ioutil.ReadDir(".")
	if err != nil {
		panic(err)
	}
	buf := bytes.NewBuffer(nil)
	buf.Write([]byte("// Code generated by generator/main.go, DO NOT EDIT.\n\n"))
	buf.Write([]byte("package defaultconfig \n\nconst (\n"))
	for _, f := range fs {
		if strings.HasSuffix(f.Name(), ".yml") {
			buf.Write([]byte(strings.Title(strings.TrimSuffix(f.Name(), ".yml")) + " = `"))
			f, _ := os.Open(f.Name())
			io.Copy(buf, f)
			buf.Write([]byte("`\n"))
		}
	}
	buf.Write([]byte(")\n"))
	formated, err := format.Source(buf.Bytes())
	if err != nil {
		panic(err)
	}
	out, err := os.Create(*outName)
	if err != nil {
		panic(err)
	}
	_, err = out.Write(formated)
	if err != nil {
		panic(err)
	}
	err = out.Close()
	if err != nil {
		panic(err)
	}
}
